require('Misc')

Scene = {}
Scene.private = {}
Scene.characters = {}
--Scene.characters.null = newCharacter(' ',love.image.newImageData(1, 1))

function Scene.new(background,dialogs,rawWindow,font)
	local scene = {}
	scene.width = rawWindow.width
	scene.height = rawWindow.height
	scene.borderColor = rawWindow.borderColor
	scene.backColor = rawWindow.backColor
	scene.textColor = rawWindow.textColor
	scene.hTextColor = rawWindow.hTextColor
	scene.x = rawWindow.x
	scene.y = rawWindow.y
	scene.background = background
	scene.dialogs = dialogs
	scene.font = font
	--scene.kind = 'Scene'
	--scene.parent = 'Scene'
	return scene
end

function Scene.load(scene)
	if scene == nil then
		return
	end

	if scene.font ~= nil then
		love.graphics.setFont(scene.font)
	end

	local characters = Scene.characters
	local dialogs = scene.dialogs

	local index = 1
	local oldindex = 1

	local char = scene.dialogs[index].character.image

	local rect = Window.new(dialogs[index].text,scene.width,scene.height,scene.borderColor,scene.backColor,scene.textColor, scene.y)

	love.graphics.setCanvas(rect)
	love.graphics.setColor(scene.hTextColor)
	love.graphics.print(scene.dialogs[index].character.name,10,2)
	love.graphics.setColor(255,255,255)
	love.graphics.setCanvas()

	scene.index = index
	scene.char = char
	scene.rect = rect

	return scene
end

function Scene.draw(scene,cx,cy,rx,ry)
	love.graphics.draw(scene.background)
	love.graphics.draw(scene.char,cx,cy)
	love.graphics.draw(scene.rect,rx,ry)
end

function Scene.keypressed(scene,key)
	if key == 'return' then
		if scene.index < #(scene.dialogs) then
			scene.index = scene.index + 1
			if scene.dialogs[scene.index].kind == 'text' then
				Scene.private.textonly(scene)
			elseif scene.dialogs[scene.index].kind == 'options' then
				Scene.private.options(scene)
			end
		else
			return true
		end
	end
	return scene
end

function Scene.private.textonly(scene)
	scene.rect = Window.new(scene.dialogs[scene.index].text, scene.width, scene.height, scene.borderColor, scene.backColor, scene.textColor, scene.y)
	love.graphics.setCanvas(scene.rect)
	love.graphics.setColor(scene.hTextColor)
	love.graphics.print(scene.dialogs[scene.index].character.name,10,2)
	love.graphics.setColor(255,255,255)
	love.graphics.setCanvas()
end

function Scene.private.options(scene)
	scene.rect = Selectable.new(scene.dialogs[scene.index].text, scene.width, scene.height, scene.dialogs[scene.index].toptext, scene.dialogs[scene.index].spacing, scene.borderColor, scene.backColor, scene.textColor, scene.y)
end

