Selectable = {}
Selectable.width = 100
Selectable.height = 100
Selectable.spacing = 10
Selectable.borderColor = {255,255,255}
Selectable.backColor = {255,255,255}
Selectable.textColor = {255,255,255}

function Selectable.new(options,width,height,toptext,spacing,borderColor,backColor,textColor)
	if width == nil then
		width = Selectable.width
	end

	if height == nil then
		height = Selectable.height
	end

	if borderColor == nil then
		borderColor = Selectable.borderColor
	end

	if backColor == nil then
		backColor = Selectable.backColor
	end

	if textColor == nil then
		textColor = Selectable.textColor
	end

	if toptext == nil then
		toptext = ''
		spacing = 0
	end

	if spacing == nil then
		spacing = Selectable.spacing
	end

	local rect = love.graphics.newCanvas(width,height)

	love.graphics.setCanvas(rect)
	
	love.graphics.setColor(backColor)
	love.graphics.rectangle('fill', 0, 0, width, height)

	love.graphics.setColor(borderColor)
	love.graphics.rectangle('line', 1, 1, width-2, height-2)

	love.graphics.setColor(textColor)

	for key,value in pairs(options) do
		love.graphics.printf(value, 2, (key+1)*spacing, width-2)
	end

	love.graphics.setColor(255,255,255)

	love.graphics.setCanvas()

	return rect
end
