Window = {}
Window.width = 100
Window.height = 100
Window.borderColor = {255,255,255}
Window.backColor = {255,255,255}
Window.textColor = {255,255,255}

function Window.new(text,width,height,borderColor,backColor,textColor,textY)
	if width == nil then
		width = Window.width
	end

	if height == nil then
		height = Window.height
	end

	if borderColor == nil then
		borderColor = Window.borderColor
	end

	if backColor == nil then
		backColor = Window.backColor
	end

	if textColor == nil then
		textColor = Window.textColor
	end

	if textY == nil then
		textY = 2
	end

	local rect = love.graphics.newCanvas(width,height)

	love.graphics.setCanvas(rect)
	
	love.graphics.setColor(backColor)
	love.graphics.rectangle('fill', 0, 0, width, height)

	love.graphics.setColor(borderColor)
	love.graphics.rectangle('line', 1, 1, width-2, height-2)

	love.graphics.setColor(textColor)
	love.graphics.printf(text, 2, textY, width-2)

	love.graphics.setColor(255,255,255)

	love.graphics.setCanvas()

	return rect
end

function Window.raw(width,height,borderColor,backColor,textColor,hTextColor,x,y)
	if width == nil then
		width = Window.width
	end

	if height == nil then
		height = Window.height
	end

	if borderColor == nil then
		borderColor = Window.borderColor
	end

	if backColor == nil then
		backColor = Window.backColor
	end

	if textColor == nil then
		textColor = Window.textColor
	end

	if hTextColor == nil then
		hTextColor = textColor
	end

	local rect = {}

	rect.width = width
	rect.height = height
	rect.borderColor = borderColor
	rect.backColor = backColor
	rect.textColor = textColor
	rect.hTextColor = hTextColor
	rect.x = x
	rect.y = y
	rect.kind = 'Window'
	return rect
end
